
/*  A Bison parser, made from hpc-y.y
 by  GNU Bison version 1.25
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	PROGRAM	258
#define	FUNCTION	259
#define	PROCEDURE	260
#define	VAR	261
#define	UNBOUND	262
#define	EXTERNAL	263
#define	AT	264
#define	OF	265
#define	TYPEOF	266
#define	IF	267
#define	THEN	268
#define	ENDIF	269
#define	ELSE	270
#define	CASE	271
#define	START	272
#define	DO	273
#define	STEP	274
#define	NEXT	275
#define	UNTIL	276
#define	WHILE	277
#define	REPEAT	278
#define	KWBEGIN	279
#define	END	280
#define	TOP	281
#define	KW_NULL	282
#define	REAL	283
#define	NATURAL	284
#define	CHAR	285
#define	STRING	286
#define	BINARY	287
#define	LIST	288
#define	COMPLEX	289
#define	ARRAY	290
#define	LONGREAL	291
#define	LONGCOMPLEX	292
#define	RE	293
#define	IM	294
#define	INDEX0	295
#define	INDEX1	296
#define	BREAK	297
#define	OVER	298
#define	DUP	299
#define	SWAP	300
#define	ROT	301
#define	ROLL	302
#define	ROLLD	303
#define	DEPTH	304
#define	DROP	305
#define	LIT_NATURAL	306
#define	LIT_REAL	307
#define	LIT_BINARY	308
#define	LIT_BOOLEAN	309
#define	LIT_CHAR	310
#define	LIT_STRING	311
#define	IDN	312
#define	ASSIGN	313
#define	OR	314
#define	AND	315
#define	NOT	316
#define	EQUAL	317
#define	GE	318
#define	LE	319
#define	NE	320
#define	SHL	321
#define	SHR	322
#define	ASR	323
#define	ROR	324
#define	ROL	325
#define	UMINUS	326

#line 20 "hpc-y.y"

#include <config.h>
#include <stdarg.h>
#include "node.h"
#include "util.h"

extern int yylineno;
extern int yylex();
extern void output_code(const char*, struct st_node*);
static int type_nybble(struct type*);
static int type_check(struct type*, struct type*, int);
static void arg_type_check(const char*);
static int code_dispatch_list(void);
static void yyerror(const char*);

/*	Checks whether a type has an ordering relation, like < */
static inline int is_ordered(int tag) {
	return tag == NATURAL
		|| tag == REAL
		|| tag == LONGREAL
		|| tag == BINARY;
}

#ifdef __GNUC__
static char rcsid[] __attribute__((unused)) = "$Id: hpc-y.y,v 1.1 2000-01-08 09:22:59+01 zeljko Exp $";
#else
static char rcsid[] = "$Id: hpc-y.y,v 1.1 2000-01-08 09:22:59+01 zeljko Exp $";
#endif

#line 50 "hpc-y.y"
typedef union {
	struct st_node *op;
	struct type    *ty;
} YYSTYPE;
#line 55 "hpc-y.y"

/* stack that holds parameter or argument lists */
static struct st_node *argstk[256];
static int sp = -1;

/* current declaration scope */
static enum scope scope = GLOBAL;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		283
#define	YYFLAG		-32768
#define	YYNTBASE	89

#define YYTRANSLATE(x) ((unsigned)(x) <= 326 ? yytranslate[x] : 124)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,    81,    74,     2,    87,
    88,    79,    77,    58,    78,     2,    80,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,    84,    83,    63,
     2,    64,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
    85,     2,    86,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,    75,     2,    76,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
    46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
    56,    57,    59,    60,    61,    62,    65,    66,    67,    68,
    69,    70,    71,    72,    73,    82
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     3,     5,     6,     8,    11,    15,    19,    21,    25,
    27,    31,    38,    47,    49,    51,    53,    55,    57,    59,
    61,    63,    65,    67,    68,    70,    72,    74,    77,    80,
    83,    84,    91,    92,    93,   103,   111,   116,   117,   124,
   125,   126,   136,   142,   145,   151,   158,   162,   167,   169,
   173,   175,   179,   182,   186,   190,   197,   200,   206,   214,
   218,   227,   235,   240,   246,   250,   252,   254,   256,   259,
   265,   267,   269,   271,   273,   275,   277,   281,   285,   288,
   290,   294,   298,   301,   305,   310,   315,   319,   323,   327,
   331,   335,   339,   345,   347,   349,   351,   354,   358,   361,
   368,   371,   374,   377,   380,   382,   384,   386,   388,   390,
   392,   396,   400,   404,   408,   412,   416,   420,   423,   426,
   429,   432,   435,   438,   442,   445,   448,   453,   457,   459,
   461
};

static const short yyrhs[] = {    90,
    97,     0,    91,     0,     0,    92,     0,    91,    92,     0,
     6,    93,    83,     0,    94,    84,    95,     0,    57,     0,
    94,    58,    57,     0,    96,     0,    35,    10,    96,     0,
    35,    85,    51,    86,    10,    96,     0,    35,    85,    51,
    58,    51,    86,    10,    96,     0,    33,     0,    28,     0,
    36,     0,    29,     0,    31,     0,    32,     0,    30,     0,
    34,     0,    37,     0,    98,     0,     0,    99,     0,   104,
     0,   109,     0,    98,    99,     0,    98,   104,     0,    98,
   109,     0,     0,     8,   100,   103,     9,    51,    83,     0,
     0,     0,   101,   103,    83,   102,    90,    24,   114,    25,
    83,     0,     4,    57,    87,   113,    88,    84,    95,     0,
     4,    57,    84,    95,     0,     0,     8,   105,   108,     9,
    51,    83,     0,     0,     0,   106,   108,    83,   107,    90,
    24,   114,    25,    83,     0,     5,    57,    87,   113,    88,
     0,     5,    57,     0,   110,    24,   111,    25,    83,     0,
     3,    57,    87,    51,    88,    83,     0,   112,    84,    57,
     0,   111,   112,    84,    57,     0,    95,     0,   112,    58,
    95,     0,    93,     0,   113,    83,    93,     0,   115,    83,
     0,   114,   115,    83,     0,    57,    59,   120,     0,    57,
    85,   120,    86,    59,   120,     0,    57,   122,     0,    12,
   119,    13,   114,    14,     0,    12,   119,    13,   114,    15,
   114,    14,     0,    16,   116,    25,     0,    17,   120,    58,
   120,    18,   114,    19,   120,     0,    17,   120,    58,   120,
    18,   114,    20,     0,    18,   114,    21,   119,     0,    22,
   119,    23,   114,    25,     0,    26,    59,   120,     0,    42,
     0,   118,     0,   117,     0,   116,   117,     0,   119,    13,
   114,    25,    83,     0,    43,     0,    44,     0,    45,     0,
    46,     0,    49,     0,    50,     0,    47,    84,   120,     0,
    48,    84,   120,     0,    84,   120,     0,    54,     0,   119,
    61,   119,     0,   119,    60,   119,     0,    62,   119,     0,
    87,   119,    88,     0,   119,    61,    13,   119,     0,   119,
    60,    15,   119,     0,   120,    64,   120,     0,   120,    63,
   120,     0,   120,    66,   120,     0,   120,    67,   120,     0,
   120,    68,   120,     0,   120,    65,   120,     0,    11,   118,
    26,    65,    95,     0,   121,     0,    40,     0,    41,     0,
    95,    26,     0,    95,   118,    26,     0,    95,   120,     0,
    34,    87,   120,    58,   120,    88,     0,    38,   120,     0,
    39,   120,     0,    27,    33,     0,    27,    31,     0,    56,
     0,    55,     0,    51,     0,    52,     0,    53,     0,    57,
     0,   120,    77,   120,     0,   120,    78,   120,     0,   120,
    79,   120,     0,   120,    80,   120,     0,   120,    81,   120,
     0,   120,    74,   120,     0,   120,    75,   120,     0,    76,
   120,     0,    69,   120,     0,    70,   120,     0,    71,   120,
     0,    73,   120,     0,    72,   120,     0,    87,   120,    88,
     0,    78,   120,     0,    57,   122,     0,    57,    85,   120,
    86,     0,    87,   123,    88,     0,    26,     0,   120,     0,
   123,    58,   120,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
    93,    96,    97,   100,   101,   104,   107,   129,   134,   141,
   142,   147,   152,   157,   163,   164,   165,   166,   167,   168,
   169,   170,   173,   174,   177,   178,   179,   180,   181,   182,
   185,   185,   191,   191,   191,   198,   205,   214,   214,   220,
   220,   220,   227,   234,   242,   245,   253,   265,   279,   284,
   291,   292,   295,   296,   300,   307,   315,   323,   325,   327,
   329,   338,   346,   348,   350,   352,   353,   356,   358,   362,
   366,   367,   368,   369,   370,   371,   372,   377,   382,   389,
   390,   392,   394,   396,   398,   400,   402,   408,   414,   420,
   426,   431,   436,   440,   441,   442,   443,   445,   447,   455,
   460,   465,   470,   472,   474,   475,   478,   479,   480,   481,
   482,   487,   492,   497,   502,   508,   514,   520,   525,   530,
   535,   540,   545,   550,   552,   554,   562,   571,   573,   577,
   583
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","PROGRAM",
"FUNCTION","PROCEDURE","VAR","UNBOUND","EXTERNAL","AT","OF","TYPEOF","IF","THEN",
"ENDIF","ELSE","CASE","START","DO","STEP","NEXT","UNTIL","WHILE","REPEAT","KWBEGIN",
"END","TOP","KW_NULL","REAL","NATURAL","CHAR","STRING","BINARY","LIST","COMPLEX",
"ARRAY","LONGREAL","LONGCOMPLEX","RE","IM","INDEX0","INDEX1","BREAK","OVER",
"DUP","SWAP","ROT","ROLL","ROLLD","DEPTH","DROP","LIT_NATURAL","LIT_REAL","LIT_BINARY",
"LIT_BOOLEAN","LIT_CHAR","LIT_STRING","IDN","','","ASSIGN","OR","AND","NOT",
"'<'","'>'","EQUAL","GE","LE","NE","SHL","SHR","ASR","ROR","ROL","'&'","'|'",
"'~'","'+'","'-'","'*'","'/'","'%'","UMINUS","';'","':'","'['","']'","'('","')'",
"unit","vardecl","vardecl1","varstmt","typedfn","varlist","type","simpletype",
"subroutines","subrlist","function","@1","@2","@3","funchdr","procedure","@4",
"@5","@6","prochdr","program","proghdr","dispatch","typelist","formalparm","statements",
"statement","condlist","casecond","stackop","boolexpr","expr","arithexp","actualparm",
"exprlist", NULL
};
#endif

static const short yyr1[] = {     0,
    89,    90,    90,    91,    91,    92,    93,    94,    94,    95,
    95,    95,    95,    95,    96,    96,    96,    96,    96,    96,
    96,    96,    97,    97,    98,    98,    98,    98,    98,    98,
   100,    99,   101,   102,    99,   103,   103,   105,   104,   106,
   107,   104,   108,   108,   109,   110,   111,   111,   112,   112,
   113,   113,   114,   114,   115,   115,   115,   115,   115,   115,
   115,   115,   115,   115,   115,   115,   115,   116,   116,   117,
   118,   118,   118,   118,   118,   118,   118,   118,   118,   119,
   119,   119,   119,   119,   119,   119,   119,   119,   119,   119,
   119,   119,   119,   120,   120,   120,   120,   120,   120,   120,
   120,   120,   120,   120,   120,   120,   121,   121,   121,   121,
   121,   121,   121,   121,   121,   121,   121,   121,   121,   121,
   121,   121,   121,   121,   121,   121,   121,   122,   122,   123,
   123
};

static const short yyr2[] = {     0,
     2,     1,     0,     1,     2,     3,     3,     1,     3,     1,
     3,     6,     8,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     0,     1,     1,     1,     2,     2,     2,
     0,     6,     0,     0,     9,     7,     4,     0,     6,     0,
     0,     9,     5,     2,     5,     6,     3,     4,     1,     3,
     1,     3,     2,     3,     3,     6,     2,     5,     7,     3,
     8,     7,     4,     5,     3,     1,     1,     1,     2,     5,
     1,     1,     1,     1,     1,     1,     3,     3,     2,     1,
     3,     3,     2,     3,     4,     4,     3,     3,     3,     3,
     3,     3,     5,     1,     1,     1,     2,     3,     2,     6,
     2,     2,     2,     2,     1,     1,     1,     1,     1,     1,
     3,     3,     3,     3,     3,     3,     3,     2,     2,     2,
     2,     2,     2,     3,     2,     2,     4,     3,     1,     1,
     3
};

static const short yydefact[] = {     3,
     0,    24,     2,     4,     8,     0,     0,     0,    31,     1,
    23,    25,     0,    26,     0,    27,     0,     5,     6,     0,
     0,     0,     0,     0,    28,    29,    30,     0,     0,     0,
     0,     0,     9,    15,    17,    20,    18,    19,    14,    21,
     0,    16,    22,     7,    10,     0,     0,     0,     0,    34,
    44,    41,    49,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     3,     0,     3,     0,     0,     0,     0,    11,
     0,     0,     0,     0,    37,    51,     0,     0,     0,     0,
    45,     0,    50,    47,     0,     0,    46,    32,    39,     0,
     0,     0,    43,     0,    48,     0,     0,    52,     0,     0,
     0,     0,     0,     0,     0,    66,    71,    72,    73,    74,
     0,     0,    75,    76,     0,     0,     0,     0,    67,     0,
     0,    12,    36,     0,     0,    21,     0,     0,    95,    96,
   107,   108,   109,    80,   106,   105,   110,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    94,
     0,    68,     0,     0,     0,     0,     0,     0,     0,     0,
   129,     0,     0,     0,    57,    79,     0,     0,    53,     0,
     0,     0,   104,   103,     0,   101,   102,     0,   126,    83,
   119,   120,   121,   123,   122,   118,   125,     0,     0,    97,
     0,    99,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    60,    69,
     0,     0,     0,     0,     0,    65,    77,    78,    55,     0,
   130,     0,    35,    54,    42,    13,     0,     0,     0,    84,
   124,    98,     0,     0,    82,     0,    81,    88,    87,    92,
    89,    90,    91,   116,   117,   111,   112,   113,   114,   115,
     0,     0,    63,     0,     0,     0,   128,     0,     0,   127,
    58,     0,    86,    85,     0,     0,    64,     0,   131,    93,
     0,     0,    70,     0,    56,   100,    59,     0,    62,    61,
     0,     0,     0
};

static const short yydefgoto[] = {   281,
     2,     3,     4,    76,     7,   147,    45,    10,    11,    12,
    23,    13,    63,    29,    14,    24,    15,    65,    31,    16,
    17,    54,    55,    77,   117,   118,   151,   152,   119,   153,
   149,   150,   165,   222
};

static const short yypact[] = {    11,
   -30,   159,    11,-32768,-32768,   -62,   -50,   -26,    30,-32768,
   159,-32768,    67,-32768,    36,-32768,    53,-32768,-32768,    24,
   560,     7,    67,    36,-32768,-32768,-32768,    46,    22,    68,
    52,   560,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
    -9,-32768,-32768,-32768,-32768,    85,   129,   130,   -74,-32768,
    62,-32768,-32768,   431,   -36,   226,   101,    71,   110,   114,
   560,   -30,    11,   -30,    11,    88,    17,   560,   111,-32768,
   -28,    89,    91,    92,-32768,-32768,   -63,   152,   -59,   155,
-32768,   126,-32768,-32768,   133,   184,-32768,-32768,-32768,   -30,
   113,   777,-32768,   777,-32768,   109,   226,-32768,   560,   365,
   365,   880,   777,   365,   137,-32768,-32768,-32768,-32768,-32768,
   132,   134,-32768,-32768,     2,   880,   518,   115,-32768,   561,
   207,-32768,-32768,    98,    29,   136,   880,   880,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,   -22,   365,   880,   880,
   880,   880,   880,   880,   880,   365,   819,     6,   915,-32768,
   174,-32768,    19,   880,    76,   604,   -16,   880,   880,   880,
-32768,   880,   880,   880,-32768,   206,   138,   141,-32768,   149,
   226,   193,-32768,-32768,   880,-32768,-32768,   880,-32768,-32768,
    50,    50,    50,    50,    50,    50,-32768,   -45,   896,-32768,
   208,-32768,   777,   238,   302,   880,   880,   880,   880,   880,
   880,   880,   880,   880,   880,   880,   880,   880,-32768,-32768,
   777,   224,   880,   365,   777,   206,   206,   206,   206,   425,
   206,   -49,-32768,-32768,-32768,-32768,   168,   112,   471,-32768,
-32768,-32768,   432,   365,   177,   365,-32768,   206,   206,   206,
   206,   206,   206,    50,    50,     3,     3,-32768,-32768,-32768,
   647,    18,    60,   690,   176,   880,-32768,   560,   880,-32768,
-32768,   777,   177,-32768,   156,   777,-32768,   880,   206,-32768,
   351,   734,-32768,   475,   206,-32768,-32768,   880,-32768,   206,
   240,   241,-32768
};

static const short yypgoto[] = {-32768,
    37,-32768,   239,     1,-32768,   -21,   -38,-32768,-32768,   237,
-32768,-32768,-32768,   228,   248,-32768,-32768,-32768,   258,   253,
-32768,-32768,   234,   232,   -89,  -114,-32768,   146,  -101,   -14,
   -90,-32768,   169,-32768
};


#define	YYLAST		996


static const short yytable[] = {    44,
    56,     6,   168,   161,   120,   168,   215,    20,   256,    61,
    53,   155,    62,   156,   194,   195,     1,    70,   193,    90,
    19,    68,   172,    90,    91,   166,     5,   161,    93,    85,
    22,   211,    53,    21,   -38,   266,   176,   177,   257,    75,
    30,   168,   230,   194,   195,   191,    83,    69,   181,   182,
   183,   184,   185,   186,   187,   189,   192,    86,   122,   173,
   162,   174,   178,   212,   164,   194,   195,   216,   217,   218,
    28,   219,   220,   221,    68,    57,    32,   123,   194,   195,
    33,   206,   207,   208,   228,   148,   163,   229,   164,   157,
    98,   202,   203,    46,   204,   205,   206,   207,   208,    78,
    82,    80,    49,   233,    50,   238,   239,   240,   241,   242,
   243,   244,   245,   246,   247,   248,   249,   250,   168,   194,
   195,   251,   252,   180,    51,   254,   204,   205,   206,   207,
   208,   188,   226,   213,    52,    58,   168,    59,    60,   168,
   107,   108,   109,   110,   111,   112,   113,   114,    64,   202,
   203,    71,   204,   205,   206,   207,   208,   168,    72,   168,
    73,     8,   -33,   -40,    74,   269,     9,    84,   271,   259,
    81,    87,   272,    88,    89,    92,   274,   275,    94,   235,
   237,   116,    95,    96,   124,   202,   203,   280,   204,   205,
   206,   207,   208,    97,   121,   158,    99,   169,   209,   253,
   125,    34,    35,    36,    37,    38,    39,   126,    41,    42,
    43,   127,   128,   129,   130,   159,   171,   160,   227,   263,
   223,   264,   175,   224,   131,   132,   133,   134,   135,   136,
   137,   225,   258,   232,   268,   138,   270,   195,   273,   282,
   283,    18,   139,   140,   141,   142,   143,    25,   124,   144,
    47,   145,   234,    34,    35,    36,    37,    38,    26,    40,
   146,    42,    43,    27,   125,    34,    35,    36,    37,    38,
    39,   126,    41,    42,    43,   127,   128,   129,   130,   202,
   203,    48,   204,   205,   206,   207,   208,    67,   131,   132,
   133,   134,   135,   136,   137,    79,   210,   202,   203,   138,
   204,   205,   206,   207,   208,   179,   139,   140,   141,   142,
   143,   231,   124,   144,   236,   145,     0,     0,     0,     0,
     0,     0,     0,     0,   146,     0,     0,     0,   125,    34,
    35,    36,    37,    38,    39,   126,    41,    42,    43,   127,
   128,   129,   130,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   131,   132,   133,   134,   135,   136,   137,     0,
     0,     0,     0,   138,     0,     0,     0,     0,     0,     0,
   139,   140,   141,   142,   143,   124,     0,   144,     0,   145,
     0,     0,     0,     0,     0,     0,     0,     0,   146,     0,
     0,   125,    34,    35,    36,    37,    38,    39,   126,    41,
    42,    43,   127,   128,   129,   130,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   131,   132,   133,   134,   135,
   136,   137,     0,     0,   202,   203,   138,   204,   205,   206,
   207,   208,     0,   139,   140,   141,   142,   143,   276,     0,
   144,     0,   145,   100,     0,   261,   262,   101,   102,   103,
     0,   146,     0,   104,     0,    66,     0,   105,    34,    35,
    36,    37,    38,    39,    40,    41,    42,    43,     0,     0,
     0,     0,     0,   106,   107,   108,   109,   110,   111,   112,
   113,   114,     0,     0,     0,     0,   100,     0,   115,     0,
   101,   102,   103,   278,   279,     0,   104,     0,   202,   203,
   105,   204,   205,   206,   207,   208,     0,     0,     0,     0,
   255,     0,     0,     0,     0,   116,   106,   107,   108,   109,
   110,   111,   112,   113,   114,     0,     0,     0,     0,   100,
     0,   115,     0,   101,   102,   103,     0,     0,     0,   104,
     0,     0,   167,   105,   202,   203,     0,   204,   205,   206,
   207,   208,     0,     0,     0,     0,   260,     0,   116,   106,
   107,   108,   109,   110,   111,   112,   113,   114,     0,     0,
     0,     0,   100,     0,   115,     0,   101,   102,   103,     0,
     0,     0,   104,     0,     0,   170,   105,    34,    35,    36,
    37,    38,    39,    40,    41,    42,    43,     0,     0,     0,
     0,   116,   106,   107,   108,   109,   110,   111,   112,   113,
   114,     0,     0,     0,     0,   100,     0,   115,     0,   101,
   102,   103,     0,     0,   214,   104,     0,     0,     0,   105,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   116,   106,   107,   108,   109,   110,
   111,   112,   113,   114,     0,     0,     0,     0,   100,     0,
   115,     0,   101,   102,   103,     0,     0,     0,   104,     0,
     0,   265,   105,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   116,   106,   107,
   108,   109,   110,   111,   112,   113,   114,     0,     0,     0,
     0,   100,     0,   115,     0,   101,   102,   103,     0,     0,
     0,   104,     0,     0,   267,   105,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   116,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     0,     0,     0,     0,     0,   100,   115,   277,     0,   101,
   102,   103,     0,     0,     0,   104,     0,     0,     0,   105,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,   116,     0,   106,   107,   108,   109,   110,
   111,   112,   113,   114,     0,     0,     0,     0,   100,     0,
   115,     0,   101,   102,   103,     0,     0,     0,   104,     0,
     0,     0,   105,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   116,   106,   107,
   108,   109,   110,   111,   112,   113,   114,     0,     0,     0,
     0,     0,     0,   115,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   190,   125,    34,    35,    36,    37,
    38,    39,   126,    41,    42,    43,   127,   128,   129,   130,
   116,   107,   108,   109,   110,   111,   112,   113,   114,   131,
   132,   133,     0,   135,   136,   137,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   139,   140,   141,
   142,   143,     0,     0,   144,     0,   145,     0,     0,     0,
     0,     0,   116,     0,     0,   154,   125,    34,    35,    36,
    37,    38,    39,   126,    41,    42,    43,   127,   128,   129,
   130,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   131,   132,   133,     0,   135,   136,   137,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   139,   140,
   141,   142,   143,     0,     0,   144,     0,   145,   196,   197,
   198,   199,   200,   201,     0,     0,   154,     0,     0,   202,
   203,     0,   204,   205,   206,   207,   208,   196,   197,   198,
   199,   200,   201,   231,     0,     0,     0,     0,   202,   203,
     0,   204,   205,   206,   207,   208
};

static const short yycheck[] = {    21,
    10,     1,   117,    26,    94,   120,    23,    58,    58,    84,
    32,   102,    87,   103,    60,    61,     6,    56,    13,    83,
    83,    58,   124,    83,    88,   116,    57,    26,    88,    58,
    57,    13,    54,    84,     5,    18,   127,   128,    88,    61,
     5,   156,    88,    60,    61,   147,    68,    84,   139,   140,
   141,   142,   143,   144,   145,   146,   147,    86,    97,    31,
    59,    33,    85,   154,    87,    60,    61,   158,   159,   160,
     4,   162,   163,   164,    58,    85,    24,    99,    60,    61,
    57,    79,    80,    81,   175,   100,    85,   178,    87,   104,
    90,    74,    75,    87,    77,    78,    79,    80,    81,    63,
    84,    65,    57,   193,    83,   196,   197,   198,   199,   200,
   201,   202,   203,   204,   205,   206,   207,   208,   233,    60,
    61,   211,   213,   138,    57,   215,    77,    78,    79,    80,
    81,   146,   171,    58,    83,    51,   251,     9,     9,   254,
    43,    44,    45,    46,    47,    48,    49,    50,    87,    74,
    75,    51,    77,    78,    79,    80,    81,   272,    88,   274,
    51,     3,     4,     5,    51,   256,     8,    57,   259,    58,
    83,    83,   262,    83,    83,    24,   266,   268,    24,   194,
   195,    84,    57,    51,    11,    74,    75,   278,    77,    78,
    79,    80,    81,    10,    86,    59,    84,    83,    25,   214,
    27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
    37,    38,    39,    40,    41,    84,    10,    84,    26,   234,
    83,   236,    87,    83,    51,    52,    53,    54,    55,    56,
    57,    83,    65,    26,    59,    62,   258,    61,    83,     0,
     0,     3,    69,    70,    71,    72,    73,    11,    11,    76,
    23,    78,    15,    28,    29,    30,    31,    32,    11,    34,
    87,    36,    37,    11,    27,    28,    29,    30,    31,    32,
    33,    34,    35,    36,    37,    38,    39,    40,    41,    74,
    75,    24,    77,    78,    79,    80,    81,    54,    51,    52,
    53,    54,    55,    56,    57,    64,   151,    74,    75,    62,
    77,    78,    79,    80,    81,   137,    69,    70,    71,    72,
    73,    88,    11,    76,    13,    78,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    87,    -1,    -1,    -1,    27,    28,
    29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
    39,    40,    41,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    51,    52,    53,    54,    55,    56,    57,    -1,
    -1,    -1,    -1,    62,    -1,    -1,    -1,    -1,    -1,    -1,
    69,    70,    71,    72,    73,    11,    -1,    76,    -1,    78,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,    -1,
    -1,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    41,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    51,    52,    53,    54,    55,
    56,    57,    -1,    -1,    74,    75,    62,    77,    78,    79,
    80,    81,    -1,    69,    70,    71,    72,    73,    88,    -1,
    76,    -1,    78,    12,    -1,    14,    15,    16,    17,    18,
    -1,    87,    -1,    22,    -1,    25,    -1,    26,    28,    29,
    30,    31,    32,    33,    34,    35,    36,    37,    -1,    -1,
    -1,    -1,    -1,    42,    43,    44,    45,    46,    47,    48,
    49,    50,    -1,    -1,    -1,    -1,    12,    -1,    57,    -1,
    16,    17,    18,    19,    20,    -1,    22,    -1,    74,    75,
    26,    77,    78,    79,    80,    81,    -1,    -1,    -1,    -1,
    86,    -1,    -1,    -1,    -1,    84,    42,    43,    44,    45,
    46,    47,    48,    49,    50,    -1,    -1,    -1,    -1,    12,
    -1,    57,    -1,    16,    17,    18,    -1,    -1,    -1,    22,
    -1,    -1,    25,    26,    74,    75,    -1,    77,    78,    79,
    80,    81,    -1,    -1,    -1,    -1,    86,    -1,    84,    42,
    43,    44,    45,    46,    47,    48,    49,    50,    -1,    -1,
    -1,    -1,    12,    -1,    57,    -1,    16,    17,    18,    -1,
    -1,    -1,    22,    -1,    -1,    25,    26,    28,    29,    30,
    31,    32,    33,    34,    35,    36,    37,    -1,    -1,    -1,
    -1,    84,    42,    43,    44,    45,    46,    47,    48,    49,
    50,    -1,    -1,    -1,    -1,    12,    -1,    57,    -1,    16,
    17,    18,    -1,    -1,    21,    22,    -1,    -1,    -1,    26,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    84,    42,    43,    44,    45,    46,
    47,    48,    49,    50,    -1,    -1,    -1,    -1,    12,    -1,
    57,    -1,    16,    17,    18,    -1,    -1,    -1,    22,    -1,
    -1,    25,    26,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    42,    43,
    44,    45,    46,    47,    48,    49,    50,    -1,    -1,    -1,
    -1,    12,    -1,    57,    -1,    16,    17,    18,    -1,    -1,
    -1,    22,    -1,    -1,    25,    26,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    84,    42,    43,    44,    45,    46,    47,    48,    49,    50,
    -1,    -1,    -1,    -1,    -1,    12,    57,    14,    -1,    16,
    17,    18,    -1,    -1,    -1,    22,    -1,    -1,    -1,    26,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    84,    -1,    42,    43,    44,    45,    46,
    47,    48,    49,    50,    -1,    -1,    -1,    -1,    12,    -1,
    57,    -1,    16,    17,    18,    -1,    -1,    -1,    22,    -1,
    -1,    -1,    26,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    42,    43,
    44,    45,    46,    47,    48,    49,    50,    -1,    -1,    -1,
    -1,    -1,    -1,    57,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    26,    27,    28,    29,    30,    31,
    32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
    84,    43,    44,    45,    46,    47,    48,    49,    50,    51,
    52,    53,    -1,    55,    56,    57,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    69,    70,    71,
    72,    73,    -1,    -1,    76,    -1,    78,    -1,    -1,    -1,
    -1,    -1,    84,    -1,    -1,    87,    27,    28,    29,    30,
    31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
    41,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    51,    52,    53,    -1,    55,    56,    57,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    69,    70,
    71,    72,    73,    -1,    -1,    76,    -1,    78,    63,    64,
    65,    66,    67,    68,    -1,    -1,    87,    -1,    -1,    74,
    75,    -1,    77,    78,    79,    80,    81,    63,    64,    65,
    66,    67,    68,    88,    -1,    -1,    -1,    -1,    74,    75,
    -1,    77,    78,    79,    80,    81
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/lib/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 196 "/usr/lib/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 7:
#line 108 "hpc-y.y"
{
					int i;
					
					/* All variables in varlist are on the stack. Assign them
					 * type and put them in the symbol table. */
					for(i = 0; i <= sp; i++) {
						argstk[i]->type = yyvsp[0].ty;
						argstk[i]->type->scope = scope;
						if(scope == GLOBAL) {
							if(!add_global_name(argstk[i]->class.identifier.name, argstk[i]->type)) error(yylineno, "duplicate identifier");
							argstk[i]->type->pos = -1;
						} else {
							/* parameters and local variables go together */
							argstk[i]->type->pos = i;
							if(!add_local_name(argstk[i]->class.identifier.name, argstk[i]->type)) error(yylineno, "duplicate identifier");
						}
					}
					sp = -1;
				;
    break;}
case 8:
#line 130 "hpc-y.y"
{
					if(sp >= 256) error(yylineno, "argument stack xceeded");
					argstk[++sp] = yyvsp[0].op;
				;
    break;}
case 9:
#line 135 "hpc-y.y"
{
					if(sp >= 256) error(yylineno, "argument stack exceeded");
					argstk[++sp] = yyvsp[0].op;
				;
    break;}
case 11:
#line 143 "hpc-y.y"
{
					if(yyvsp[0].ty->type_tag != REAL && yyvsp[0].ty->type_tag !=COMPLEX) error(yylineno, "only REAL or COMPLEX arrays allowed");
					yyval.ty = new_type(ARRAY, yyvsp[0].ty, 0);
				;
    break;}
case 12:
#line 148 "hpc-y.y"
{
					if(yyvsp[0].ty->type_tag != REAL && yyvsp[0].ty->type_tag !=COMPLEX) error(yylineno, "only REAL or COMPLEX arrays allowed");
					yyval.ty = new_type(ARRAY, yyvsp[0].ty, 1, yyvsp[-3].op->class.literal.natural);
				;
    break;}
case 13:
#line 153 "hpc-y.y"
{
					if(yyvsp[0].ty->type_tag != REAL && yyvsp[0].ty->type_tag !=COMPLEX) error(yylineno, "only REAL or COMPLEX arrays allowed");
					yyval.ty = new_type(ARRAY, yyvsp[0].ty, 2, yyvsp[-5].op->class.literal.natural, yyvsp[-3].op->class.literal.natural);
				;
    break;}
case 14:
#line 158 "hpc-y.y"
{
					yyval.ty = new_type(LIST);
				;
    break;}
case 25:
#line 177 "hpc-y.y"
{ ;
    break;}
case 26:
#line 178 "hpc-y.y"
{ ;
    break;}
case 27:
#line 179 "hpc-y.y"
{ ;
    break;}
case 31:
#line 185 "hpc-y.y"
{ scope = PARAM; ;
    break;}
case 32:
#line 186 "hpc-y.y"
{
					if(yyvsp[-1].op->class.literal.natural < 0 || yyvsp[-1].op->class.literal.natural > 0xFFFFF) error(yylineno, "invalid address");
					yyvsp[-3].op->type->class.subroutine.external = yyvsp[-1].op->class.literal.natural;
					clear_local_names();
				;
    break;}
case 33:
#line 191 "hpc-y.y"
{ scope = PARAM; ;
    break;}
case 34:
#line 191 "hpc-y.y"
{ scope = LOCAL; ;
    break;}
case 35:
#line 192 "hpc-y.y"
{
					output_code(yyvsp[-7].op->class.identifier.name, yyvsp[-2].op);
					clear_local_names();
				;
    break;}
case 36:
#line 199 "hpc-y.y"
{
					/* there are no local variables other than parameters. */
					yyvsp[-5].op->type = new_type(FUNCTION, yyvsp[0].ty);
					if(!add_global_name(yyvsp[-5].op->class.identifier.name, yyvsp[-5].op->type)) error(yylineno, "duplicate identifier");
					yyval.op = yyvsp[-5].op;
				;
    break;}
case 37:
#line 206 "hpc-y.y"
{
					yyvsp[-2].op->type = new_type(FUNCTION, yyvsp[0].ty);
					if(!add_global_name(yyvsp[-2].op->class.identifier.name, yyvsp[-2].op->type)) error(yylineno, "duplicate identifier");
					yyval.op = yyvsp[-2].op;
				;
    break;}
case 38:
#line 214 "hpc-y.y"
{ scope = PARAM; ;
    break;}
case 39:
#line 215 "hpc-y.y"
{
					if(yyvsp[-1].op->class.literal.natural < 0 || yyvsp[-1].op->class.literal.natural > 0xFFFFF) error(yylineno, "invalid address");
					yyvsp[-3].op->type->class.subroutine.external = yyvsp[-1].op->class.literal.natural;
					clear_local_names();
				;
    break;}
case 40:
#line 220 "hpc-y.y"
{ scope = PARAM; ;
    break;}
case 41:
#line 220 "hpc-y.y"
{ scope = LOCAL; ;
    break;}
case 42:
#line 221 "hpc-y.y"
{
					output_code(yyvsp[-7].op->class.identifier.name, yyvsp[-2].op);
					clear_local_names();
				;
    break;}
case 43:
#line 228 "hpc-y.y"
{
					/* there are no local variables other than parameters. */
					yyvsp[-3].op->type = new_type(PROCEDURE);
					if(!add_global_name(yyvsp[-3].op->class.identifier.name, yyvsp[-3].op->type)) error(yylineno, "duplicate identifier");
					yyval.op = yyvsp[-3].op;
				;
    break;}
case 44:
#line 235 "hpc-y.y"
{
					yyvsp[0].op->type = new_type(PROCEDURE);
					if(!add_global_name(yyvsp[0].op->class.identifier.name, yyvsp[0].op->type)) error(yylineno, "duplicate identifier");
					yyval.op = yyvsp[0].op;
				;
    break;}
case 45:
#line 243 "hpc-y.y"
{ output_code(yyvsp[-4].op->class.identifier.name, new_st_control(PROGRAM, NULL, yyvsp[-2].op, yyvsp[-4].op->type->class.subroutine.nargs, NULL)); ;
    break;}
case 46:
#line 246 "hpc-y.y"
{
					yyvsp[-4].op->type = new_type(PROGRAM, yyvsp[-2].op->class.literal.natural);
					if(yyvsp[-2].op->class.literal.natural < 0 || yyvsp[-2].op->class.literal.natural > 5) error(yylineno, "invalid number for dispatch list");
					if(!add_global_name(yyvsp[-4].op->class.identifier.name, yyvsp[-4].op->type)) error(yylineno, "duplicate identifier"); 
					yyval.op = yyvsp[-4].op;
				;
    break;}
case 47:
#line 254 "hpc-y.y"
{
					int type_code;
					
					if(yyvsp[0].op->type == NULL) error(yylineno, "undeclared identifier");
					if(yyvsp[0].op->type->type_tag != PROCEDURE && yyvsp[0].op->type->type_tag != FUNCTION) error(yylineno, "not a procedure/function");
					if(sp > 4) error(yylineno, "programs can be dispatched on at most 5 arguments");
					arg_type_check(yyvsp[0].op->class.identifier.name);
					type_code = code_dispatch_list();
					yyval.op = new_st_control(DISPATCH, NULL, type_code, yyvsp[0].op, NULL);
					sp = -1;
				;
    break;}
case 48:
#line 266 "hpc-y.y"
{
					int type_code;
					
					if(yyvsp[0].op->type == NULL) error(yylineno, "undeclared identifier");
					if(yyvsp[0].op->type->type_tag != PROCEDURE && yyvsp[0].op->type->type_tag != FUNCTION) error(yylineno, "not a procedure/function");
					if(sp > 4) error(yylineno, "programs can be dispatched on at most 5 arguments");
					arg_type_check(yyvsp[0].op->class.identifier.name);
					type_code = code_dispatch_list();
					yyval.op = new_st_control(',', NULL, yyvsp[-3].op, new_st_control(DISPATCH, NULL, type_code, yyvsp[0].op, NULL));
					sp = -1;
				;
    break;}
case 49:
#line 280 "hpc-y.y"
{
					if(sp >= 256) error(yylineno, "type stack exceeded");
					argstk[++sp] = new_st_control(-1, yyvsp[0].ty, NULL);
				;
    break;}
case 50:
#line 285 "hpc-y.y"
{
					if(sp >= 256) error(yylineno, "type stack exceeded");
					argstk[++sp] = new_st_control(-1, yyvsp[0].ty, NULL);
				;
    break;}
case 54:
#line 297 "hpc-y.y"
{ yyval.op = new_st_control(';', NULL, yyvsp[-2].op, yyvsp[-1].op, NULL); ;
    break;}
case 55:
#line 301 "hpc-y.y"
{
					/* lexical analyzer locates the IDN in the symbol table */
					if(yyvsp[-2].op->type == NULL) error(yylineno, "undeclared identifier");
					type_check(yyvsp[-2].op->type, yyvsp[0].op->type, 1);
					yyval.op = new_st_control(ASSIGN, NULL, yyvsp[-2].op, yyvsp[0].op, NULL);
				;
    break;}
case 56:
#line 308 "hpc-y.y"
{
					if(yyvsp[-5].op->type == NULL) error(yylineno, "undeclared identifier");
					if(yyvsp[-5].op->type->type_tag != ARRAY) error(yylineno, "not an array");
					if(yyvsp[-3].op->type->type_tag != NATURAL) error(yylineno, "array index is not an natural");
					type_check(yyvsp[-5].op->type->class.array.elemtype, yyvsp[0].op->type, 1);
					yyval.op = new_st_control(ARRPUT, NULL, yyvsp[-5].op, yyvsp[-3].op, yyvsp[0].op, NULL);
				;
    break;}
case 57:
#line 316 "hpc-y.y"
{
					if(yyvsp[-1].op->type == NULL) error(yylineno, "undeclared identifier");
					if(yyvsp[-1].op->type->type_tag != PROCEDURE) error(yylineno, "not a procedure call");
					arg_type_check(yyvsp[-1].op->class.identifier.name);
					yyval.op = new_st_control(PROCEDURE, NULL, yyvsp[-1].op, yyvsp[0].op, NULL);
					sp = -1;
				;
    break;}
case 58:
#line 324 "hpc-y.y"
{ yyval.op = new_st_control(IF, NULL, yyvsp[-3].op, yyvsp[-1].op, NULL); ;
    break;}
case 59:
#line 326 "hpc-y.y"
{ yyval.op = new_st_control(ELSE, NULL, yyvsp[-5].op, yyvsp[-3].op, yyvsp[-1].op, NULL); ;
    break;}
case 60:
#line 328 "hpc-y.y"
{ yyval.op = new_st_control(CASE, NULL, yyvsp[-1].op, NULL); ;
    break;}
case 61:
#line 330 "hpc-y.y"
{
					if((yyvsp[-6].op->type->type_tag != NATURAL)
					|| (yyvsp[-4].op->type->type_tag != NATURAL)
					|| (yyvsp[0].op->type->type_tag != NATURAL)) {
						error(yylineno, "natural expression required for loop bounds/step expression");
					}
					yyval.op = new_st_control(START, NULL, yyvsp[-6].op, yyvsp[-4].op, yyvsp[-2].op, yyvsp[0].op, NULL);
				;
    break;}
case 62:
#line 339 "hpc-y.y"
{
					if((yyvsp[-5].op->type->type_tag != NATURAL)
					|| (yyvsp[-3].op->type->type_tag != NATURAL)) {
						error(yylineno, "natural expression required for loop bounds");
					}
					yyval.op = new_st_control(NEXT, NULL, yyvsp[-5].op, yyvsp[-3].op, yyvsp[-1].op, NULL);
				;
    break;}
case 63:
#line 347 "hpc-y.y"
{ yyval.op = new_st_control(DO, NULL, yyvsp[-2].op, yyvsp[0].op, NULL); ;
    break;}
case 64:
#line 349 "hpc-y.y"
{ yyval.op = new_st_control(WHILE, NULL, yyvsp[-3].op, yyvsp[-1].op, NULL); ;
    break;}
case 65:
#line 351 "hpc-y.y"
{ yyval.op = new_st_control(PUSH, NULL, yyvsp[0].op, NULL); ;
    break;}
case 68:
#line 357 "hpc-y.y"
{ yyval.op = new_st_control(',', NULL, yyvsp[0].op, NULL); ;
    break;}
case 69:
#line 359 "hpc-y.y"
{ yyval.op = new_st_control(',', NULL, yyvsp[-1].op, yyvsp[0].op, NULL); ;
    break;}
case 70:
#line 363 "hpc-y.y"
{ yyval.op = new_st_control(THEN, NULL, yyvsp[-4].op, yyvsp[-2].op, NULL); ;
    break;}
case 77:
#line 373 "hpc-y.y"
{
					if(yyvsp[0].op->type->type_tag != NATURAL) error(yylineno, "natural expression required for stack depth");
					yyval.op = new_st_control(ROLL, NULL, yyvsp[0].op, NULL);
				;
    break;}
case 78:
#line 378 "hpc-y.y"
{
					if(yyvsp[0].op->type->type_tag != NATURAL) error(yylineno, "natural expression required for stack depth");
					yyval.op = new_st_control(ROLLD, NULL, yyvsp[0].op, NULL);
				;
    break;}
case 79:
#line 383 "hpc-y.y"
{
					if(yyvsp[0].op->type->type_tag != NATURAL) error(yylineno, "natural expression required for stack depth");
					yyval.op = new_st_control(':', NULL, yyvsp[0].op, NULL);
				;
    break;}
case 81:
#line 391 "hpc-y.y"
{ yyval.op = new_st_control(AND, NULL, yyvsp[-2].op, yyvsp[0].op, NULL); ;
    break;}
case 82:
#line 393 "hpc-y.y"
{ yyval.op = new_st_control(OR, NULL, yyvsp[-2].op, yyvsp[0].op, NULL); ;
    break;}
case 83:
#line 395 "hpc-y.y"
{ yyval.op = new_st_control(NOT, NULL, yyvsp[0].op, NULL); ;
    break;}
case 84:
#line 397 "hpc-y.y"
{ yyval.op = yyvsp[-1].op; ;
    break;}
case 85:
#line 399 "hpc-y.y"
{ yyval.op = new_st_control(ANDTHEN, NULL, yyvsp[-3].op, yyvsp[0].op, NULL); ;
    break;}
case 86:
#line 401 "hpc-y.y"
{ yyval.op = new_st_control(ORELSE, NULL, yyvsp[-3].op, yyvsp[0].op, NULL); ;
    break;}
case 87:
#line 403 "hpc-y.y"
{
					type_check(yyvsp[-2].op->type, yyvsp[0].op->type, 1);
					if(!is_ordered(yyvsp[-2].op->type->type_tag)) error(yylineno, "invalid type");
					yyval.op = new_st_control('>', yyvsp[-2].op->type, yyvsp[-2].op, yyvsp[0].op, NULL);
				;
    break;}
case 88:
#line 409 "hpc-y.y"
{
					type_check(yyvsp[-2].op->type, yyvsp[0].op->type, 1);
					if(!is_ordered(yyvsp[-2].op->type->type_tag)) error(yylineno, "invalid type");
					yyval.op = new_st_control('<', yyvsp[-2].op->type, yyvsp[-2].op, yyvsp[0].op, NULL);
				;
    break;}
case 89:
#line 415 "hpc-y.y"
{
					type_check(yyvsp[-2].op->type, yyvsp[0].op->type, 1);
					if(!is_ordered(yyvsp[-2].op->type->type_tag)) error(yylineno, "invalid type");
					yyval.op = new_st_control(GE, yyvsp[-2].op->type, yyvsp[-2].op, yyvsp[0].op, NULL);
				;
    break;}
case 90:
#line 421 "hpc-y.y"
{
					type_check(yyvsp[-2].op->type, yyvsp[0].op->type, 1);
					if(!is_ordered(yyvsp[-2].op->type->type_tag)) error(yylineno, "invalid type");
					yyval.op = new_st_control(LE, yyvsp[-2].op->type, yyvsp[-2].op, yyvsp[0].op, NULL);
				;
    break;}
case 91:
#line 427 "hpc-y.y"
{
					type_check(yyvsp[-2].op->type, yyvsp[0].op->type, 1);
					yyval.op = new_st_control(NE, yyvsp[-2].op->type, yyvsp[-2].op, yyvsp[0].op, NULL);
				;
    break;}
case 92:
#line 432 "hpc-y.y"
{
					type_check(yyvsp[-2].op->type, yyvsp[0].op->type, 1);
					yyval.op = new_st_control(EQUAL, yyvsp[-2].op->type, yyvsp[-2].op, yyvsp[0].op, NULL);
				;
    break;}
case 93:
#line 437 "hpc-y.y"
{ yyval.op = new_st_control(TYPEOF, NULL, yyvsp[-3].op, yyvsp[0].ty, NULL); ;
    break;}
case 97:
#line 444 "hpc-y.y"
{ yyval.op = new_st_control(TOP, yyvsp[-1].ty, NULL); ;
    break;}
case 98:
#line 446 "hpc-y.y"
{ yyval.op = yyvsp[-1].op; yyval.op->type = yyvsp[-2].ty; ;
    break;}
case 99:
#line 448 "hpc-y.y"
{
					if(yyvsp[0].op->type != NULL) {
						yyval.op = new_st_control(yyvsp[-1].ty->type_tag, yyvsp[-1].ty, yyvsp[0].op, NULL);
					} else {
						yyval.op = yyvsp[0].op;
					}
				;
    break;}
case 100:
#line 456 "hpc-y.y"
{
					if(yyvsp[-3].op->type->type_tag != REAL || yyvsp[-1].op->type->type_tag != REAL) error(yylineno, "two reals expected in `complex'");
					yyval.op = new_st_control(RE2COMPLEX, new_type(COMPLEX), yyvsp[-3].op, yyvsp[-1].op, NULL);
				;
    break;}
case 101:
#line 461 "hpc-y.y"
{
					if(yyvsp[0].op->type->type_tag != COMPLEX) error(yylineno, "`re' can only be used on COMPLEX expressions");
					yyval.op = new_st_control(RE, new_type(REAL), yyvsp[0].op, NULL);
				;
    break;}
case 102:
#line 466 "hpc-y.y"
{
					if(yyvsp[0].op->type->type_tag != COMPLEX) error(yylineno, "`im' can be used only on COMPLEX expressions");
					yyval.op = new_st_control(IM, new_type(REAL), yyvsp[0].op, NULL);
				;
    break;}
case 103:
#line 471 "hpc-y.y"
{ yyval.op = new_st_control(KW_NULL, new_type(LIST), NULL); ;
    break;}
case 104:
#line 473 "hpc-y.y"
{ yyval.op = new_st_control(KW_NULL, new_type(STRING), NULL); ;
    break;}
case 111:
#line 483 "hpc-y.y"
{
					type_check(yyvsp[-2].op->type, yyvsp[0].op->type, 1);
					yyval.op = new_st_control('+', yyvsp[-2].op->type, yyvsp[-2].op, yyvsp[0].op, NULL);
				;
    break;}
case 112:
#line 488 "hpc-y.y"
{
					type_check(yyvsp[-2].op->type, yyvsp[0].op->type, 1);
					yyval.op = new_st_control('-', yyvsp[-2].op->type, yyvsp[-2].op, yyvsp[0].op, NULL);
				;
    break;}
case 113:
#line 493 "hpc-y.y"
{
					type_check(yyvsp[-2].op->type, yyvsp[0].op->type, 1);
					yyval.op = new_st_control('*', yyvsp[-2].op->type, yyvsp[-2].op, yyvsp[0].op, NULL);
				;
    break;}
case 114:
#line 498 "hpc-y.y"
{
					type_check(yyvsp[-2].op->type, yyvsp[0].op->type, 1);
					yyval.op = new_st_control('/', yyvsp[-2].op->type, yyvsp[-2].op, yyvsp[0].op, NULL);
				;
    break;}
case 115:
#line 503 "hpc-y.y"
{
					type_check(yyvsp[-2].op->type, yyvsp[0].op->type, 1);
					if(yyvsp[-2].op->type->type_tag != NATURAL && yyvsp[-2].op->type->type_tag != REAL) error(yylineno, "invalid type");
					yyval.op = new_st_control('%', yyvsp[-2].op->type, yyvsp[-2].op, yyvsp[0].op, NULL);
				;
    break;}
case 116:
#line 509 "hpc-y.y"
{
					type_check(yyvsp[-2].op->type, yyvsp[0].op->type, 1);
					if(yyvsp[-2].op->type->type_tag != BINARY) error(yylineno, "invalid type");
					yyval.op = new_st_control('&', yyvsp[-2].op->type, yyvsp[-2].op, yyvsp[0].op, NULL);
				;
    break;}
case 117:
#line 515 "hpc-y.y"
{
					type_check(yyvsp[-2].op->type, yyvsp[0].op->type, 1);
					if(yyvsp[-2].op->type->type_tag != BINARY) error(yylineno, "invalid type");
					yyval.op = new_st_control('|', yyvsp[-2].op->type, yyvsp[-2].op, yyvsp[0].op, NULL);
				;
    break;}
case 118:
#line 521 "hpc-y.y"
{
					if(yyvsp[0].op->type->type_tag != BINARY) error(yylineno, "invalid type");
					yyval.op = new_st_control('~', yyvsp[0].op->type, yyvsp[0].op, NULL);
				;
    break;}
case 119:
#line 526 "hpc-y.y"
{
					if(yyvsp[0].op->type->type_tag != BINARY) error(yylineno, "invalid type");
					yyval.op = new_st_control(SHL, yyvsp[0].op->type, yyvsp[0].op, NULL);
				;
    break;}
case 120:
#line 531 "hpc-y.y"
{
					if(yyvsp[0].op->type->type_tag != BINARY) error(yylineno, "invalid type");
					yyval.op = new_st_control(SHR, yyvsp[0].op->type, yyvsp[0].op, NULL);
				;
    break;}
case 121:
#line 536 "hpc-y.y"
{
					if(yyvsp[0].op->type->type_tag != BINARY) error(yylineno, "invalid type");
					yyval.op = new_st_control(ASR, yyvsp[0].op->type, yyvsp[0].op, NULL);
				;
    break;}
case 122:
#line 541 "hpc-y.y"
{
					if(yyvsp[0].op->type->type_tag != BINARY) error(yylineno, "invalid type");
					yyval.op = new_st_control(ROL, yyvsp[0].op->type, yyvsp[0].op, NULL);
				;
    break;}
case 123:
#line 546 "hpc-y.y"
{
					if(yyvsp[0].op->type->type_tag != BINARY) error(yylineno, "invalid type");
					yyval.op = new_st_control(ROR, yyvsp[0].op->type, yyvsp[0].op, NULL);
				;
    break;}
case 124:
#line 551 "hpc-y.y"
{ yyval.op = yyvsp[-1].op; ;
    break;}
case 125:
#line 553 "hpc-y.y"
{ yyval.op = new_st_control(UMINUS, yyvsp[0].op->type, yyvsp[0].op, NULL); ;
    break;}
case 126:
#line 555 "hpc-y.y"
{
					if(yyvsp[-1].op->type == NULL) error(yylineno, "undeclared identifier");
					if(yyvsp[-1].op->type->type_tag != FUNCTION) error(yylineno, "not a function call");
					arg_type_check(yyvsp[-1].op->class.identifier.name);
					yyval.op = new_st_control(FUNCTION, yyvsp[-1].op->type->class.subroutine.retarg, yyvsp[-1].op, yyvsp[0].op, NULL);
					sp = -1;
				;
    break;}
case 127:
#line 563 "hpc-y.y"
{
					if(yyvsp[-3].op->type == NULL) error(yylineno, "undeclared identifier");
					if(yyvsp[-3].op->type->type_tag != ARRAY) error(yylineno, "not an array");
					if(yyvsp[-1].op->type->type_tag != NATURAL) error(yylineno, "index is not a NATURAL");
					yyval.op = new_st_control(ARRGET, yyvsp[-3].op->type->class.array.elemtype, yyvsp[-3].op, yyvsp[-1].op, NULL);
				;
    break;}
case 128:
#line 572 "hpc-y.y"
{ yyval.op = yyvsp[-1].op; ;
    break;}
case 129:
#line 574 "hpc-y.y"
{ yyval.op = NULL; ;
    break;}
case 130:
#line 578 "hpc-y.y"
{
					if(sp >= 256) error(yylineno, "argument stack exceeded");
					argstk[++sp] = yyvsp[0].op;
					yyval.op = yyvsp[0].op;
				;
    break;}
case 131:
#line 584 "hpc-y.y"
{
					if(sp >= 256) error(yylineno, "argument stack exceeded");
					argstk[++sp] = yyvsp[0].op;
					yyval.op = new_st_control(',', NULL, yyvsp[-2].op, yyvsp[0].op, NULL);
				;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 498 "/usr/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 589 "hpc-y.y"


/*	Check the equality of types. */
static int
type_check(struct type *t1, struct type *t2, int terminate)
{
	/* NULL pointer is no type and is compatible with every other type. */
	if(t1 == NULL || t2 == NULL) {
		return 1;
	}
	if(t1->type_tag == ARRAY) {
		if(t2->type_tag != ARRAY) return 0;
		return t1->class.array.elemtype->type_tag == t2->class.array.elemtype->type_tag;
	}
	if(!terminate) return t1->type_tag == t2->type_tag;
	if(t1->type_tag != t2->type_tag) error(yylineno, "type mismatch");
	return 1;
}

/*	conversion of  USER type into RPL nybble */
static int
type_nybble(struct type *t)
{
	switch(t->type_tag) {
		case REAL: 		return 1;
		case COMPLEX:	return 2;
		case STRING:	return 3;
		case ARRAY:		return 4;	/* SysRPL knows only about ARRAYs */
		case LIST:		return 5;
		case BINARY:	return 11;
		default:		return -1;
	}
}

static void
arg_type_check(const char *subname)
{
	int i;
	struct type *t = find_name(subname);

	if(sp+1 != t->class.subroutine.nargs) error(yylineno, "wrong number of arguments to subroutine call");
	for(i = 0; i < t->class.subroutine.nargs; i++) {
		if(!type_check(argstk[i]->type, t->class.subroutine.args[i], 0)) error(yylineno, "wrong argument type");
	}
}

static int
code_dispatch_list(void)
{
	int i, tq, type_code = 0;

	for(i = 0; i <= sp; i++) {
		if((tq = type_nybble(argstk[i]->type)) < 0) error(yylineno, "programs can be dispatched on user type only");
		type_code = (type_code << 4) | tq;
	}
	return type_code;
}

static void yyerror(const char *s)
{
	fprintf(stderr, "%d: %s\n", yylineno, s);
}

