
#ifndef __SATURN_H__
#define __SATURN_H__

#include <stdarg.h>

/*	Functions for writing saturn RPL code directly to file. */
void saturn_openw(const char*, const char*);
int saturn_close(void);
void saturn_ptr5(int);
void saturn_real(double, int);
void saturn_string(const char*);
void saturn_hexstr(int, const char*);
void saturn_id(const char*);
void saturn_entry(const char*);
void saturn_print(const char*, va_list);

#endif	/* __SATURN_H__ */

